/***************************************************************************
                          maptile_door.cpp  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "maptile_door.h"
#include "resources.h"
#include "map.h"
#include "game.h"
#include "map_sample.h"
#include "player.h"
#include "sprite.h"

Maptile_door::Maptile_door(int _x, int _y, int _dt, WorldType _wt, Map* _map) : Maptile(_x, _y, _wt, _map)
{
	blocking=false;
	fallt=true;
	sur=Resources::Tiles();

	switch(_dt)
	{
	case 0:
		sprite=new Sprite(sur, 0.1f, 24, 28);
		locked=false;
		mt=DNORM;
	break;
	case 1:
		sprite=new Sprite(sur, 10.0f, 12, 12);
		locked=true;
		mt=DOORR;
	break;
	case 2:
		sprite=new Sprite(sur, 10.f, 0, 0);
		locked=true;
		mt=DOORG;
	break;
	}
}
Maptile_door::~Maptile_door()
{
}
void Maptile_door::show()
{
	if(mt!=DNORM)
	sprite->put_screen(x, y);
	else if(map->game->sample->no_gold() && !locked)
	sprite->put_screen(x, y);	
}
void Maptile_door::act()
{
	if(mt!=DNORM && locked==false && sprite->is_played() && map->game->sample->no_gold()==false)
	{
		if(mt==DOORR)
		sprite->set_new(10.0f, 15, 15);				
		else
		sprite->set_new(10.0f, 3, 3);
	}
	else if(mt!=DNORM && locked==false && map->game->sample->no_gold())
	{
		if(mt==DOORR)
		sprite->set_new(0.1f, 16, 20);				
		else
		sprite->set_new(0.1f, 4, 8);
	}

	if(map->game->sample->no_gold() && !locked)
	{
	  if(map->game->sample->p1->map_x(16)==x && map->game->sample->p1->map_y(16)==y)
    {
      Resources::Finish()->play();
		  map->game->sample->next();
	    map->game->sample->p1->gain_life();	
    }
		else if(map->game->get_t()==true)
		if(map->game->sample->p2->map_x(16)==x && map->game->sample->p2->map_y(16)==y)
    {
      Resources::Finish()->play();
		  map->game->sample->next();
	    map->game->sample->p2->gain_life();
    }
	}
}
void Maptile_door::unlock()
{

	if(locked==true)
	{		
    PLAY(Resources::Doorunlock());
		if(mt==DOORR)
		{
			sprite->set_new(0.1f, 12, 16);				
		}
		else
		{
			sprite->set_new(0.1f, 0, 4);					
		}		
		locked=false;
	}
}