/***************************************************************************
                          player.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "player.h"
#include "controller.h"
#include "resources.h"
#include "sprite.h"
#include "map.h"
#include "maptile.h"
#include "map_sample.h"
#include "global_types.h"
#include "timer.h"
#include "sprite.h"
#include "maptile_teleporter.h"
#include "maptile_door.h"
#include "maptile_normal.h"
#include "maptile_empty.h"
#include "tool.h"
#include "tool_befudlementgas.h"
#include "tool_gold.h"
#include "tool_bomb.h"
#include "tool_key.h"
#include "bomb.h"
#include "tool_abomb.h"
#include "tool_bbomb.h"
#include "tool_pickaxe.h"
#include "tool_slimebucket.h"
#include "tool_exploder.h"
#include "tool_life.h"
#include "tool_trap.h"
#include "tool_jackhammer.h"
#include "tool_syringe.h"
#include "tool_gold.h"
#include "tool_lasertripmine.h"
#include "tool_acid.h"
#include "gas_cloud.h"
#include "cbomb.h"
#include "acid.h"
#include "lasertripmine.h"
#include "trap.h"
#include "debris.h"
#include "slime.h"
#include "beam.h"
#include "explosion.h"

Player::Player(int _x, int _y, bool _t, Map_Sample* _sample) : Gameobject(_x, _y, _sample)
{
	dir=STOPPED;
	ty=_t;
	got=PLAYER;
	controller=new Controller(this);
	controller->set_locked(true);
	falling=false;
	is_hidden=false;
	fob=false;
	speed=140.0f;
	bl=1;
	port=false;
	make=false;
	ttimer=new Timer;
	ctimer=new Timer;
	bar=new Timer;
	transfer=false;
	bombs=0;
	own=NONE;
	btask=false;
	drill=0;
	sliming=gased=pick=0;
	score=0;
	lives=4;
	died=false;
	tlx=tly=0;
	trapped=0;
	eated=0;

  if(ty)
	sur=Resources::Playerr();
  else
	sur=Resources::Player();

	sprite=new Sprite(sur, 10.0f, 0, 0);
}
void Player::reset()
{
	controller->set_locked(true);
	dir=STOPPED;
	falling=false;
	is_hidden=false;
	fob=false;
	speed=140.0f;
	bl=1;
	port=false;
	make=false;
	gased=0;
	sliming=0;
	drill=0;
	trapped=0;
	bombs=0;
	own=NONE;
	btask=false;
	drill=0;
	died=false;
	sliming=pick=0;	
	eated=0;
	ctimer->reset();
	timer->reset();
	ttimer->reset();

	sprite->set_new(10.0f, 0, 0);
}
Player::~Player()
{
}
bool Player::is_hunted()
{
	if(lives>0 && died==false && is_hidden==false && !port)
	return true;	
	else
	return false;
}
void Player::die()
{
	if(!died && !port)
	{
		if(!eated)
		new Beam(x, y, sample);

    PLAY(Resources::Die());

		trigger_bombs=true;	

		if(own!=NONE)
		{
			switch(own)
			{
				case TBEFUDLEMENTGAS:
					new Tool_befudlementgas(tlx, tly, sample);		
				break;
				case TBIGBOMB:
					new Tool_bbomb(tlx, tly, sample);	
				break;
				case TCBOMB:
					new Tool_abomb(tlx, tly, sample);		
				break;
				case TPICKAXE:
					new Tool_pickaxe(tlx, tly, sample);		
				break;
				case TSLIMEBUCKET:
					new Tool_slimebucket(tlx, tly, sample);		
				break;
				case TEXPLODER:
					new Tool_exploder(tlx, tly, sample);		
				break;
				case TTRAP:
					new Tool_trap(tlx, tly, sample);		
				break;
				case TJACKHAMMER:
					new Tool_jackhammer(tlx, tly, sample);		
				break;
				case TSYRINGE:
					new Tool_syringe(tlx, tly, sample);		
				break;
				case TLASERTRIPMINE:
					new Tool_lasertripmine(tlx, tly, sample);		
				break;
				case TACID:
					new Tool_acid(tlx, tly, sample);		
				break;
				case TKEYRED:
					new Tool_key(tlx, tly, 1, sample);		
				break;
				case TKEYGREEN:
					new Tool_key(tlx, tly, 0, sample);		
				break;
			}
		}	

		reset();
		x=sx;
		y=sy;
		died=true;
		lives--;
	}
}
void Player::show()
{
	if(lives>0)
	if(transfer!=true)
	sprite->put_screen(x, y);
	else
	Resources::Tiles()->put_screen(px, py, 41);	
}
void Player::act()
{
	if(lives>0)
	if(controller->is_locked())
	{
		if(ctimer->time_elapsed()>1.0f)
		controller->set_locked(false);
	}

	if(lives>0)
	if(!died)
	{
		if(transfer==true)
		check_transfer();
		else if(!trapped)
		{
			if(drill || sliming || pick)
			drilld();
			else if(!check_toolment())
			check_movement();	
		}
	}
	else
	{
		sprite->set_new(0.1f, 135, 139);
		if(controller->is_left() || controller->is_right() || controller->is_up() || controller->is_down())
    {
		  died=false;
      PLAY(Resources::Born());
    }
	}
  //reset the movement timer! (s=V*t)!
	timer->reset();
	//reset the protocol timer! (s=V*t)!
	ttimer->reset();
}
bool Player::get_t()
{
	return ty;
}
bool Player::ported()
{
	return port;
}
void Player::set_s(int _x, int _y)
{
	sx=_x;
	sy=_y;
	set_pos(sx, sy);
}
void Player::check_movement()
{
	if(sample->map->get_maptile(map_x(16), map_y())->get_type()!=TELEPORTER)
	{
		port=false;
	}
	if(sample->map->get_maptile(map_x(16), map_y())->get_type()==WATER && sample->map->get_maptile(map_x(16), map_y()+32)->get_type()!=WATER)
	{
		die(); // your corpse is now lying on the ground :)
		sprite->set_new(10.0f, 0, 0);
		y=sample->map->get_maptile(map_x(16), map_y())->get_y();
	}
	else if(((sample->map->get_maptile(map_x(16), map_y()+32)->is_fallt() || sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==WATER) && sample->map->get_maptile(map_x(16), map_y(16))->get_type()!=LADDER && sample->map->get_maptile(map_x(16), map_y(16))->get_type()!=BAR && sample->get_gameobjectg(map_x(16), map_y()+32)->get_type()!=MONK))
	{
		move(DOWN, speed+60.0f);
		falling=true;
		sprite->set_new(0.08f, 4, 6);
		x=sample->map->get_maptile(map_x(16), map_y())->get_x();

    if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==BAR)
			y=sample->map->get_maptile(map_x(16), map_y(16))->get_y();
		if(sample->map->get_maptile(map_x(16), map_y()+32)->get_type()!=WATER && sample->map->get_maptile(map_x(16), map_y()+32)->is_blocking() || sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==LADDER || sample->get_map_gameobject(map_x(16), map_y()+32)->get_type()==MONK)
		{
			y=sample->map->get_maptile(map_x(16), map_y())->get_y();
			dir=STOPPED;
			falling=false;
			sprite->set_new(10.0f, 0, 0);
		}
	}
	else
	{
	  falling=false;

		if(dir==STOPPED && controller->is_up() && sample->map->get_maptile(map_x(16), map_y())->get_type()==HIDEOUT)
		{
			is_hidden=false;
		}
		else if(is_hidden==true)
		{
			sprite->set_new(10.0f, 3, 3);
		}
		else if(controller->is_down() && sample->map->get_maptile(map_x(16), map_y())->get_type()==HIDEOUT)
		{
			is_hidden=true;
			dir=STOPPED;
			x=sample->map->get_maptile(map_x(16), map_y())->get_x();
		}
		else if(controller->is_left() && !sample->map->get_maptile(map_x(), map_y())->is_blocking())
		{
			if(sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
			{
				y=sample->map->get_maptile(map_x(16), map_y())->get_y();
				sprite->set_new(0.2f, 11, 14);
				move(LEFT, speed);
			}
			else
			{
				if(sample->map->get_maptile(map_x(16), map_y(16)+32)->get_type()==SLIME)
				move(LEFT, speed-60);
				else
				move(LEFT, speed);

				sprite->set_new(1, 0.1f, 55, 66);
			}


			if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y(16)+32)->get_type()==LADDER)
			y=sample->map->get_maptile(map_x(16), map_y(16))->get_y();
		}
		else if(controller->is_right() && (!sample->map->get_maptile(map_x()+32, map_y())->is_blocking() || !sample->map->get_maptile(map_x(-1)+32, map_y())->is_blocking()))
		{
			if(sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
			{
				y=sample->map->get_maptile(map_x(16), map_y())->get_y();
				sprite->set_new(1, 0.2f, 14, 17);
				move(RIGHT, speed);
			}
			else
			{
				if(sample->map->get_maptile(map_x(16), map_y(16)+32)->get_type()==SLIME)
				move(RIGHT, speed-60);
				else
				move(RIGHT, speed);

				sprite->set_new(0.1f, 44, 55);
			}

			if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y(16)+32)->get_type()==LADDER)
			y=sample->map->get_maptile(map_x(16), map_y(16))->get_y();
		}
		else if(dir!=STOPPED && controller->is_up() && (sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y())->get_type()==LADDER) && !sample->map->get_maptile(map_x(16), map_y())->is_blocking())
		{
			x=sample->map->get_maptile(map_x(16), map_y(16))->get_x();
			sprite->set_new(0.2f, 22, 27);
			move(UP, speed);
		}
		else if(controller->is_down() && sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
		{
      if(bar->time_elapsed()>=0.1f)
			{
        y=y+32;
  			x=sample->map->get_maptile(map_x(16), map_y())->get_x();
        bar->reset();
      }
		}
		else if(controller->is_down() && (sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y())->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y()-32)->get_type()==LADDER) && (!sample->map->get_maptile(map_x(16), map_y()+32)->is_blocking() || sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==WATER))
		{
			x=sample->map->get_maptile(map_x(16), map_y())->get_x();
			sprite->set_new(1, 0.2f, 22, 27);
			move(DOWN, speed);
		}
		else
		{
			if((dir==UP || dir==DOWN) && (sample->map->get_maptile(map_x(16), map_y())->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==LADDER))
			sprite->set_new(10.0f, 24, 24);
			else if((dir==LEFT || dir==DOWN) && sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
			{
				sprite->set_new(10.0f, 11, 11);
				y=sample->map->get_maptile(map_x(16), map_y())->get_y();
			}
			else if(dir==RIGHT && sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
			{
				sprite->set_new(10.0f, 16, 16);
				y=sample->map->get_maptile(map_x(16), map_y())->get_y();
			}
			else if(dir==RIGHT)
			sprite->set_new(10.0f, 2, 2);
			else if(dir==LEFT)
			sprite->set_new(10.0f, 1, 1);
			else if(dir==STOPPED)
			sprite->set_new(10.0f, 0, 0);
		}
	}
}
void Player::snap()
{
	x=sample->map->get_maptile(map_x(16), map_y(16))->get_x();
	y=sample->map->get_maptile(map_x(16), map_y(16))->get_y();
	sprite->set_new(10.0f, 0, 0);	
	dir=STOPPED;
}
void Player::snap2()
{
	x=sample->map->get_maptile(map_x(16), map_y(16))->get_x();
	y=sample->map->get_maptile(map_x(16), map_y(16))->get_y();
}
void Player::teleport(Maptile_teleporter *_dest)
{
	snap();
	port=true;
	dest=_dest;
	transfer=true;
	px=x;
	py=y;
}
void Player::check_transfer()
{
	if(((px>=dest->get_x() && x<=dest->get_x()) || (px<=dest->get_x() && x>=dest->get_x())) && ((py>=dest->get_y() && y<=dest->get_y()) || (py<=dest->get_y() && y>=dest->get_y())))
	{
		x=dest->get_x();
		y=dest->get_y();
		dest->sprite->play_once();
		transfer=false;
    PLAY(Resources::Teleport());
	}
	else
	{
			if(dest->get_x()<px)
			px-=(int)((ran(200)+80)*ttimer->time_elapsed());
			else if(dest->get_x()>px)
			px+=(int)((ran(200)+80)*ttimer->time_elapsed());
			if(dest->get_y()<py)
			py-=(int)((ran(200)+80)*ttimer->time_elapsed());
			else if(dest->get_y()>py)
			py+=(int)((ran(200)+80)*ttimer->time_elapsed());
	}
}
void Player::eaten()
{
	eated=true;
	die();
}
bool Player::check_toolment()
{
	make=0;
	trigger_bombs=false;

	if(gased && ctimer->time_elapsed()>=1.5f)
	{
		gased=false;
		trapped=false;
	}

	if(sample->get_gameobject(map_x(16), map_y(16))->get_type()==TOOL)
	{
		if(sample->get_tool(map_x(16), map_y(16))->get_ttype()==TGOLD)
		{
			sample->get_gameobject(map_x(16), map_y(16))->set_delme();
      PLAY(Resources::Gold());
			if(static_cast <Tool_gold*> (sample->get_gameobject(map_x(16), map_y(16)))->get_g()==0)
			score=score+25;
			if(static_cast <Tool_gold*> (sample->get_gameobject(map_x(16), map_y(16)))->get_g()==1)
			score=score+50;
			if(static_cast <Tool_gold*> (sample->get_gameobject(map_x(16), map_y(16)))->get_g()==2)
			score=score+10;			
		}
		else if(sample->get_tool(map_x(16), map_y(16))->get_ttype()==TBOMB)
		{
			if(bombs<5)
			{
				sample->get_gameobject(map_x(16), map_y(16))->set_delme();
				bombs++;
        PLAY(Resources::Pickup());
			}
		}
		else if(sample->get_tool(map_x(16), map_y(16))->get_ttype()==TLIFE)
		{
				sample->get_gameobject(map_x(16), map_y(16))->set_delme();
				lives++;
        PLAY(Resources::Life());
		}		
	}

	if(controller->is_pickup())
	{				
		if(sample->get_gameobject(map_x(16), map_y(16))->get_type()==TOOL)
		{		
			spawn_owned();
			own=sample->get_tool(map_x(16), map_y(16))->get_ttype();
			sample->get_gameobject(map_x(16), map_y(16))->set_delme();
			tlx=sample->get_gameobject(map_x(16), map_y(16))->get_x();
			tly=sample->get_gameobject(map_x(16), map_y(16))->get_y();
      PLAY(Resources::Pickup());
		}
		else if(own!=NONE)
    {
		  spawn_owned();
      PLAY(Resources::Putaway());
    }
	}

	if(controller->is_use() && own!=NONE && !is_hidden)
	{					
		if(own==TKEYRED)
		{
			if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==DOORR)
			static_cast <Maptile_door*> (sample->map->get_maptile(map_x(16), map_y(16)))->unlock();		
			make=0;
		}
		else if(own==TKEYGREEN)
		{
			if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==DOORG)
			static_cast <Maptile_door*> (sample->map->get_maptile(map_x(16), map_y(16)))->unlock();
			make=0;			
		}
		else if(own==TSYRINGE)
		{
			speed=200;
			own=NONE;
      PLAY(Resources::Speed());
		}
		else if(own==TEXPLODER)
		{
			trigger_bombs=true;		
		}
		else if(!falling && sample->map->get_maptile(map_x(16), map_y(16))->get_type()!=BAR)
		switch(own)
		{
			case TBEFUDLEMENTGAS:
	    	make=1;

				if(ctimer->time_elapsed()>0.4f)
				{
					if(dir==LEFT)
					{						
						sprite->set_new(1, 0.2f, 90, 92);
						new Gas_cloud(x-96, map_y(16), ty, sample);
					}
					else
					{					
						sprite->set_new(0.2f, 88, 90);
						new Gas_cloud(x+32, map_y(16), ty, sample);
					}
					ctimer->reset();
          PLAY(Resources::Befudlementgas());				
				}
			break;
			case TBIGBOMB:
				new Bomb(map_x(16), map_y(), 1, ty, sample);
				own=NONE;
        PLAY(Resources::Bomblit());
			break;
			case TCBOMB:
				new Cbomb(map_x(16), map_y(), sample);
				own=NONE;
        PLAY(Resources::Chput());
			break;
			case TACID:
				new Acid(map_x(16), map_y(), sample);
				own=NONE;
        PLAY(Resources::Burndown());
			break;
			case TJACKHAMMER:
				if(!drill && sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==CONCRETE)
				{
					make=1;
					drill=1;
				}
			break;
			case TLASERTRIPMINE:
				new Lasertripmine(map_x(16), map_y(), sample);
				own=NONE;
        PLAY(Resources::Putaway());
			break;
			case TPICKAXE:
				if(!pick && (dir==RIGHT && sample->map->get_maptile(map_x(16)+32, map_y())->get_type()==EMPTY) || (dir==LEFT && sample->map->get_maptile(map_x(16)-32, map_y())->get_type()==EMPTY))
				{
					make=1;
					pick=1;
					ctimer->reset();
				}
			break;
			case TSLIMEBUCKET:
				if((dir==RIGHT && sample->map->get_maptile(map_x(16)+32, map_y())->is_fallt()==true) || (dir==LEFT && sample->map->get_maptile(map_x(16)-32, map_y())->is_fallt()==true))
				{
					make=1;
					ctimer->reset();
					sliming=1;
					own=NONE;
				}
			break;
			case TTRAP:
					new Trap(map_x(16), map_y(), sample);
					own=NONE;
          PLAY(Resources::Putaway());
			break;
		}
	}

	if(!falling)
	{

		if(controller->is_bomb() && bombs>0 && sample->map->get_maptile(map_x(16), map_y(16))->get_type()!=BAR)
		{
			if(!btask)
			{
				if(own==TEXPLODER)
        {
			  	new Bomb(map_x(16), map_y(), 2, ty, sample);
          PLAY(Resources::Did());
        }
				else
        {
   				new Bomb(map_x(16), map_y(), 0, ty, sample);
          PLAY(Resources::Bomblit());
        }
				bombs--;
				btask=true;		
			}
		}
		else
		btask=false;

		if(controller->is_suicide())
		{
			new Explosion(x-48, y-48, 0, sample);
		}

		if(controller->is_digleft() && !is_hidden)
		{
			if(sample->map->get_maptile(map_x(16)-32, map_y(16)+32)->get_type()==NORMAL && (sample->map->get_maptile(map_x(16)-32, map_y(16))->get_type()==EMPTY || sample->map->get_maptile(map_x(16)-32, map_y(16))->get_type()==TELEPORTER || sample->map->get_maptile(map_x(16)-32, map_y(16))->get_type()==DNORM || sample->map->get_maptile(map_x(16)-32, map_y(16))->get_type()==DOORR || sample->map->get_maptile(map_x(16)-32, map_y(16))->get_type()==DOORG))
			{	
				sprite->set_new(1, 0.1f, 125, 129);
				static_cast <Maptile_normal*> (sample->map->get_maptile(map_x(16)-32, map_y(16)+32))->dig();	
				dir=LEFT;
			}
			make=1; //stop the player
		}

		if(controller->is_digright() && !is_hidden)
		{	
			if(sample->map->get_maptile(map_x(16)+32, map_y(16)+32)->get_type()==NORMAL && (sample->map->get_maptile(map_x(16)+32, map_y(16))->get_type()==EMPTY || sample->map->get_maptile(map_x(16)+32, map_y(16))->get_type()==TELEPORTER || sample->map->get_maptile(map_x(16)+32, map_y(16))->get_type()==DNORM || sample->map->get_maptile(map_x(16)+32, map_y(16))->get_type()==DOORR || sample->map->get_maptile(map_x(16)+32, map_y(16))->get_type()==DOORG))
			{
				sprite->set_new(0.1f, 121, 125);
				static_cast <Maptile_normal*> (sample->map->get_maptile(map_x(16)+32, map_y(16)+32))->dig();
				dir=RIGHT;
			}
			make=1; //stop the player
		}
	}

	return make;
}
void Player::spawn_owned()
{
	switch(own)
	{
		case TBEFUDLEMENTGAS:
			new Tool_befudlementgas(map_x(16), map_y(16), sample);		
		break;
		case TBIGBOMB:
			new Tool_bbomb(map_x(16), map_y(16), sample);	
		break;
		case TCBOMB:
			new Tool_abomb(map_x(16), map_y(16), sample);		
		break;
		case TPICKAXE:
			new Tool_pickaxe(map_x(16), map_y(16), sample);		
		break;
		case TSLIMEBUCKET:
			new Tool_slimebucket(map_x(16), map_y(16), sample);		
		break;
		case TEXPLODER:
			new Tool_exploder(map_x(16), map_y(16), sample);		
		break;
		case TTRAP:
			new Tool_trap(map_x(16), map_y(16), sample);		
		break;
		case TJACKHAMMER:
			new Tool_jackhammer(map_x(16), map_y(16), sample);		
		break;
		case TSYRINGE:
			new Tool_syringe(map_x(16), map_y(16), sample);		
		break;
		case TLASERTRIPMINE:
			new Tool_lasertripmine(map_x(16), map_y(16), sample);		
		break;
		case TACID:
			new Tool_acid(map_x(16), map_y(16), sample);		
		break;
		case TKEYRED:
			new Tool_key(map_x(16), map_y(16), 1, sample);		
		break;
		case TKEYGREEN:
			new Tool_key(map_x(16), map_y(16), 0, sample);		
		break;
	}
		
	own=NONE; //you've nothing :( ???
}
bool Player::triggered()
{
	return trigger_bombs;
}
void Player::drilld()
{
	if(drill)
	{
		sprite->set_new(0.2f, 6, 8);
    x=map_x(16);
		if(ctimer->time_elapsed()>=0.1f)
		{
			y=y+2;
			ctimer->reset();
		}
		if(y==sample->map->get_maptile(map_x(16), map_y())->get_y())
		{
			drill=0;
	
			sample->map->get_maptile(map_x(16), map_y())->set_delme();		
			if(sample->map->get_maptile(map_x(16), map_y())->get_type()!=DUMMY)
			new Maptile_empty(map_x(16), map_y(), (WorldType)(0), sample->map);
		}
	}

	if(sliming)
	{
		if(dir==LEFT)					
		sprite->set_new(1, 0.2f, 83, 87);
		else			
		sprite->set_new(0.2f, 77, 81);

		if(ctimer->time_elapsed()>=0.8f)
		{
			sliming=false;
      PLAY(Resources::Slime());
			if(dir==LEFT)
			{
				new Slime(map_x(16)-32, map_y(), sample);
				new Slime(map_x(16)-64, map_y(), sample);
				new Slime(map_x(16)-96, map_y(), sample);				
			}
			else
			{
				new Slime(map_x(16)+32, map_y(), sample);
				new Slime(map_x(16)+64, map_y(), sample);
				new Slime(map_x(16)+96, map_y(), sample);
			}
		}
	}
	if(pick)
	{
		if(dir==LEFT)					
		sprite->set_new(1, 0.2f, 69, 72);
		else			
		sprite->set_new(0.2f, 66, 69);

		if(ctimer->time_elapsed()>=2.0f)
		{
			pick=false;

			if(dir==LEFT)						
			new Debris(map_x(16)-32, map_y(), sample);
			else				
			new Debris(map_x(16)+32, map_y(), sample);
		}
	}
}
void Player::gain_life()
{
	lives++;
}
void Player::trap()
{
	sprite->set_new(0.2f, 9, 11);
	trapped=true;
}
void Player::gas()
{
	if(!trapped && !falling)
	{
		sprite->set_new(0.2f, 132, 135);		
		trapped=true;
		ctimer->reset();
		gased=true;
	}
}
int	Player::get_lives()
{
	return lives;
}
int	Player::get_score()
{
	return score;
}
int	Player::get_bombs()
{
	return bombs;
}
ToolType Player::get_own()
{
	return own;
}