/***************************************************************************
                          player.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLAYER_H
#define PLAYER_H

#include "gameobject.h"

/**
  *@author funthing (Matthias Zisler)
  */

class Controller;
class Sprite;
class Maptile_teleporter;

class Player : public Gameobject
{
public:
	Player(int _x, int _y, bool _t, Map_Sample* _sample);
	~Player();

	void reset();

	void show();
	void act();

	bool get_t();

	void set_s(int _x, int _y);

	bool ported();
	void snap();
	void snap2();

	void check_movement();
	void check_transfer();
	bool check_toolment();

	bool triggered();
	void gain_life();
	void spawn_owned();
	void drilld();
	void teleport(Maptile_teleporter *_dest);
	void die();
	void eaten();
	void trap();
	void gas();
	bool is_hunted();

	int	get_lives();
	int	get_score();
	int	get_bombs();
	ToolType get_own();

private:

	Maptile_teleporter* dest;
	bool transfer, btask, trigger_bombs, drill;
	Controller* controller;
	int score, lives;
	bool ty, falling, fob, is_hidden, port, make;
	int sx, sy, bl, tlx, tly;
	float px, py;
	Sprite* sprite;
	Timer* ttimer;
	Timer* ctimer;
	Timer* bar;
	int bombs;
	ToolType own;
	bool sliming, pick, died, trapped, gased, eated;
};

#endif
